# -*-Makefile-*-

parse-c:
	@$(top_builddir)/src/parser/parse-c -i $(SRC) > c-out 2> c-err

parse-gnuc:
	@$(top_builddir)/src/parser/parse-c -p GnuC -i $(SRC) > c-out 2> c-err

parse-d:
	@$(top_builddir)/src/parser/parse-c -d strict -i $(SRC) \
	  > d-out 2> d-err

$(TESTS): test
	@PWD="`pwd`"; \
	if [ x"`basename $$PWD`" = x"gcc" ]; then \
	  mkdir -p abi compat2 dwarf2 expr ieee lib misc2 overload \
		   template torture weak builtins compile eh ext \
		   inherit lookup opt parse unsorted compat \
		   debug execute format init misc other special \
		   tls warn ; \
	  for i in $(TESTS); do ln -fs ../$(srcdir)/test $$i; done; \
	else \
	  for i in $(TESTS); do ln -fs $(srcdir)/test $$i; done; \
	fi
	@rm -f log

TESTS_ENVIRONMENT = XTC_REPOSITORY=$(BUILD_REPOSITORY) SRCDIR=$(srcdir)

CLEANFILES = $(TESTS) log c-out c-err d-out d-err
