#!/usr/bin/perl -w

use strict;
use File::Spec;
use File::Temp qw/ mktemp /;

my $tmpdir = File::Spec->tmpdir();

sub open_new_file {
	my $file = mktemp("$tmpdir/TransformersXXXXXX");
	close FTMP;
	open(FTMP, '>', $file) or die "$0: Can't open `$file': $!\n";
	return $file;
}

while (@ARGV) {
	my $arg = shift @ARGV;
	my $f;
	if ($arg eq "-i") {
		close STDIN;
		$f = shift @ARGV;
		open(STDIN, "< $f") or die "$0: Can't open `$f': $!\n";
	}
	if ($arg eq "-o") {
		close STDOUT;
		$f = shift @ARGV;
		open(STDOUT, "> $f") or die "$0: Can't open `$f': $!\n";
	}
}

my $line;
my $ret = open_new_file;
print "[FILE(\"$ret\")";

while ($line = <STDIN>) {
	if ($line =~ /^# (\d+) "(.*)" 2/) {
		my $ret = open_new_file;
		print qq{,FILE("$ret")};
	}
	if ($line !~ /^#/) {
		print FTMP "$line"
	}
}

close FTMP;
print "]\n";
