# -*-Makefile-*-

parse-cxx:
	@$(top_builddir)/src/parser/parse-cxx -i $(SRC) --verbose 5 >cxx-out 2>cxx-err

parse-dxx:
	@$(top_builddir)/src/parser/parse-cxx -dxx strict -i $(SRC) \
	  >dxx-out 2>dxx-err

$(TESTS): test
	@PWD="`pwd`"; \
	if [ x"`basename $$PWD`" = x"gcc" ]; then \
	  mkdir -p abi compat eh expr ext inherit init lookup opt other \
	           overload parse special template warn; \
	  for i in $(TESTS); do ln -fs ../$(srcdir)/test $$i; done; \
	else \
	  for i in $(TESTS); do \
	    [ `echo "$$i" | grep -e '-ag$$'` ] && \
	    ln -fs $(srcdir)/test-ag $$i || ln -fs $(srcdir)/test $$i; \
	  done; \
	fi
	@rm -f log

TESTS_ENVIRONMENT = XTC_REPOSITORY=$(BUILD_REPOSITORY) SRCDIR=$(srcdir)

CLEANFILES = $(TESTS) log cxx-out cxx-err dxx-out dxx-err
