/*
 * propagator.hh: this file is a part of sdf-attribute from the
 *                Transformers project.
 *
 * Copyright (C) 2005  EPITA Research and Development Laboratory.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

#ifndef PROPAGATOR_HH_
# define PROPAGATOR_HH_

# include "checker.hh"

class Propagator
{
public:
  Propagator();
  static int propagate(Grammar& g, bool compat);

private:
  int	fillSynQuery(Production& p);
  int	cleanSynQuery(Production& p);
  int	fillInhQuery(Production& p);
  int	cleanInhQuery(Production& p);

  int	doTD(Production& p);
  int	doBU(Production& p);
  int	doLR(Production& p);

  int	removeQuery(Production& p);
  int	debug(Production& p);

  int	addDefaultSynAttribute(EvalRule& ref, Production& p);

  int	compatFillQuery(Production& p);

  Grammar *g;
  int	error_flag;
};

#endif /* !PROPAGATOR_HH_ */

