# -*-Makefile-*-

include $(top_srcdir)/config/Makefile.xt

SUFFIXES += .pp .pp.af .edef .edef.af .def.af

%.def.af: %.edef.af
	$(ESDF)/bin/sdf-strip -i $< -o $@

%.pp: %.edef.af
	$(BOXEDSDF)/bin/boxed2pp-table -i $< \
	| $(SDF_TOOLS)/bin/pp-pp-table -o $@

%.def.af : %.sdf
	$(SDF_FRONT)/bin/pack-sdf $(SDFINCLUDES) -i $< -o $@ -of ast

%.def: %.def.af
	$(SDF_FRONT)/libexec/sdf-desugar -i $< \
	| $(GPP)/bin/pp-sdf -o $@

#FIXME: duplicated rule with Makefile.xt
# %.tbl: %.def
# 	$(PGEN)/bin/sdf2table $(PGEN_FLAGS) -i $< -o $@ 2>&1 \
# 	| (grep -v 'constructor-has-already-been-used' || true)

%.c: %.str
	$(SCOMPILE) $(STRINCLUDES) $(SCFLAGS) -i $< -o $@ -c 2>&1 \
	| (grep -v '^warning: lowercase constructor name found:' || true)

%.c: %.rtree 
	$(SCOMPILE) $(STRINCLUDES) $(SCFLAGS) -i $< -o $@ -c 2>&1 \
	| (grep -v '^warning: lowercase constructor name found:' || true)

#%.pp: %.pp.af
#        $(SDF_TOOLS)/bin/pp-pp-table -i $< -o $@

###########################################################
#
# Makerules for creating table and evaluator from AG grammar.
#
# Some rules overlaps with standard ones, thus there are not
# always default targets available.
# Instead, you have to define the variable AC_GRM when using AG.
#

# Hack to help pack-esdf to pack its sdf files in a speeder
# manner, for the rule %edef.af: *.sdf
$(AG_GRM:.ag=.edef-fast): $(addprefix $(srcdir)/,$(SDFS))
	( echo definition; cat $^ ) > $@

# Maintainer rule to help catching errors in sdf files.
beat-me-im-naughty: $(addprefix $(srcdir)/,$(SDFS))
	$(ESDF)/bin/pack-esdf \
		-of ast \
		-s AttrSdf \
		-I $(SDF_ATTRIBUTE)/share/sdf-attribute \
		-I $(srcdir) \
		-i $(srcdir)/$(AG_GRM:.ag=.sdf) -o /dev/null

# This rule will be likely overriden, because other commands
# are commonly needed after pack-esdf
%.edef.af: %.edef-fast
	$(ESDF)/bin/pack-esdf \
		-of ast \
		-s AttrSdf \
		-Idef $< \
		-I $(SDF_ATTRIBUTE)/share/sdf-attribute \
		-i $(srcdir)/$(@:.edef.af=.sdf) \
	| $(SDF_TOOLS)/libexec/sdf-cons \
	| $(BOXEDSDF)/libexec/boxed-desugar -o $@

# FIXME: should be handled by esdf
%.edef: %.edef.af
	$(SDF_ATTRIBUTE)/bin/pp-attrsdf -i $< -o $@

# FIXME: should be handled by esdf
%.def: %.edef
	$(SDF_ATTRIBUTE)/bin/parse-attrsdf-definition -i $< | \
	$(ESDF)/bin/sdf-strip | \
	$(GPP)/bin/pp-sdf -o $@

# In other Makefiles, %.tbl is dependant to %.def
$(AG_GRM:.ag=.tbl): $(AG_GRM:.ag=.edef) $(AG_GRM:.ag=.def)
	$(SDF_ATTRIBUTE)/bin/attrsdf2table $(PGEN_FLAGS) -i $< -o $@ \
          $(ATTRSDF2TABLE_FLAGS)

# attrsdf2table is evil: it outputs two files, %.tbl and eval-%.str.
eval-$(AG_GRM:.ag=.str) : $(AG_GRM:.ag=.tbl)
eval-$(AG_GRM:.ag=.c) : $(AG_GRM:.ag=.str) eval-$(AG_GRM:.ag=.str)
